/*
 * node-red-config.h
 *
 *  Created on: Jun 14, 2024
 *      Author: jakubski
 */

#ifndef INC_NODE_RED_CONFIG_H_
#define INC_NODE_RED_CONFIG_H_

#include "lwip.h"

#define FEATURE_ON 1
#define FEATURE_OFF 0

#define USE_DHCP LWIP_DHCP // LWIP_DHCP defined in lwipopts.h
#define DHCP_USER_LOGS FEATURE_ON
#define UART_TASK_LOGS FEATURE_ON
// Static IP for cases when DHCP is not used or fails.
#define STATIC_IP "192.168.1.10"
#define STATIC_GW "192.168.1.0"
#define STATIC_MASK "255.255.255.0"

#define BROKER_IP "192.168.3.34"
#define MQTT_PORT 1883

#define MEASURMENTS_SCHEDULER_INTERVAL_MS 1000

//#define USER_MOCKS

#endif /* INC_NODE_RED_CONFIG_H_ */
